-- I based this GUI on the one used in the BadBoy anti-spam addon.
-- Consequently, I owe many thanks to Funkydude; permission was given to use his addon in this way.
-- Get BadBoy Anti-Spam here: https://mods.curse.com/addons/wow/bad-boy

local AddonName, AddonTable = ...
local L = AddonTable.Localize
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")

function DROptionsFrame_OnLoad()

SlashCmdList["DROPTIONS"] = optionsgui
	SLASH_DROPTIONS1 = "/dr"
	
StaticPopupDialogs["RESET_STATS"] = {
  text = L["Reset Statistics"] .. "\n\n" .. L["Are you sure?"],
  button1 = L["Yes"],
  button2 = L["No"],
  OnAccept = function()
      resetstats()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

StaticPopupDialogs["RESET_DRVARIABLES"] = {
  text = L["Reset SavedVariables"] .. "\n\n" .. L["Are you sure?"],
  button1 = L["Yes"],
  button2 = L["No"],
  OnAccept = function()
      resetvariables()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}
end

function resetvariables()

DRConfig = {
	["DeclineDuel"] = 'ON',
	["ShowChatMessage"] = 'ON',
	["ShowLoadMessage"] = 'ON',
	["DeclinePB"] = 'OFF',
	["OptionsWindow"] = 'HIDDEN',
	["AntiLag"] = 'OFF',
	["MaxLatency"] = '250',
	["FPSCheck"] = 'OFF',
	["MinFPS"] = '15',
	["ShowStats"] = 'YES',
	["HighLevelCheck"] = 'ENABLED',
	["StatsWindow"] = 'HIDDEN'
}

DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Settings returned to default values."])

end

function resetstats()
	GlobalDC = 0
	DuelsDeclined = 0
	DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Your statistics have been reset."])
end

-- START OF OPTIONS WINDOW

local DRCIOFrame = CreateFrame("Frame")
DRCIOFrame.name = L["DuelResponse"]

-- Name and Version

local lblTitle = DRCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblTitle:SetFont("Fonts\\FRIZQT__.TTF", 12)
lblTitle:SetPoint("TOPLEFT", DRCIOFrame, "TOPLEFT", 12, -12)
lblTitle:SetText(L["DuelResponse"] .. " v" .. GetAddOnMetadata("DuelResponse", "Version"))

-- CATEGORY: ANTI-DUEL

local lblCatBlockSettings = DRCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblCatBlockSettings:SetPoint("TOPLEFT", lblTitle, "BOTTOMLEFT", 0, -16)
lblCatBlockSettings:SetText("|cFFFFFFFF" .. L["Block Settings"] .. "|r")

-- Decline Duel Checkbox

local chkDeclineDuel = CreateFrame("CheckButton", nil, DRCIOFrame, "OptionsBaseCheckButtonTemplate")
chkDeclineDuel:SetPoint("TOPLEFT", lblCatBlockSettings, "BOTTOMLEFT", 0, -8)

chkDeclineDuel:SetScript("OnUpdate", function(frame)
	if DRConfig.DeclineDuel == "ON" then
		chkDeclineDuel:SetChecked(true)
	elseif DRConfig.DeclineDuel == "OFF" then
		chkDeclineDuel:SetChecked(false)
	end
end)

chkDeclineDuel:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	if tick == false then
		DRConfig.DeclineDuel = 'OFF'
			if DRConfig.ShowChatMessage == "ON" then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Duel requests will not be declined."])
			end
	elseif tick == true then
		DRConfig.DeclineDuel = 'ON'
			if DRConfig.ShowChatMessage == "ON" then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Duel requests will be declined."])
			end
	end
end)

chkDeclineDuel:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOP")
	GameTooltip:AddLine(L["Hold down Ctrl or Alt to let a request through."], 1, 1, 1)
	GameTooltip:Show()
end)

local chkDeclineDuelText = DRCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkDeclineDuelText:SetPoint("LEFT", chkDeclineDuel, "RIGHT", 0, 1)
chkDeclineDuelText:SetText("|cFFEFC502" .. L["Block all incoming duel requests"] .. "|r")

-- Pet Battle Checkbox

local chkDeclinePetBattle = CreateFrame("CheckButton", nil, DRCIOFrame, "OptionsBaseCheckButtonTemplate")
chkDeclinePetBattle:SetPoint("TOPLEFT", chkDeclineDuel, "BOTTOMLEFT")

chkDeclinePetBattle:SetScript("OnUpdate", function(frame)
	if DRConfig.DeclinePB == "ON" then
		chkDeclinePetBattle:SetChecked(true)
	elseif DRConfig.DeclinePB == "OFF" then
		chkDeclinePetBattle:SetChecked(false)
	end
end)

chkDeclinePetBattle:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	if tick == false then
		DRConfig.DeclinePB = 'OFF'
			if DRConfig.ShowChatMessage == "ON" then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Pet battle requests will not be declined."])
			end
	elseif tick == true then
		DRConfig.DeclinePB = 'ON'
			if DRConfig.ShowChatMessage == "ON" then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Pet battle requests will be declined."])
			end
	end
end)

chkDeclinePetBattle:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOP")
	GameTooltip:AddLine(L["Hold down Ctrl or Alt to let a request through."], 1, 1, 1)
	GameTooltip:Show()
end)

local chkDeclinePetBattleText = DRCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkDeclinePetBattleText:SetPoint("LEFT", chkDeclinePetBattle, "RIGHT", 0, 1)
chkDeclinePetBattleText:SetText("|cFFEFC502" .. L["Block all incoming pet battle requests"] .. "|r")

-- CATEGORY: DISPLAY

local lblCatDisplaySettings = DRCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblCatDisplaySettings:SetPoint("TOPLEFT", chkDeclinePetBattle, "BOTTOMLEFT", 0, -8)
lblCatDisplaySettings:SetText("|cFFFFFFFF" .. L["Display Settings"] .. "|r")

-- Chat Message Checkbox

local chkShowChatMsg = CreateFrame("CheckButton", nil, DRCIOFrame, "OptionsBaseCheckButtonTemplate")
chkShowChatMsg:SetPoint("TOPLEFT", lblCatDisplaySettings, "BOTTOMLEFT", 0, -8)

chkShowChatMsg:SetScript("OnUpdate", function(frame)
	if DRConfig.ShowChatMessage == "ON" then
		chkShowChatMsg:SetChecked(true)
	elseif DRConfig.ShowChatMessage == "OFF" then
		chkShowChatMsg:SetChecked(false)
	end
end)

chkShowChatMsg:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRConfig.ShowChatMessage = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Chat frame messages have been turned off."])
	elseif tick == true then
		DRConfig.ShowChatMessage = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Chat frame messages have been turned on."])
	end
end)

local chkShowChatMsgText = DRCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkShowChatMsgText:SetPoint("LEFT", chkShowChatMsg, "RIGHT", 0, 1)
chkShowChatMsgText:SetText("|cFFEFC502" .. L["Chat frame messages"] .. "|r")
	
-- Load Message Checkbox

local chkShowLoadMsg = CreateFrame("CheckButton", nil, DRCIOFrame, "OptionsBaseCheckButtonTemplate")
chkShowLoadMsg:SetPoint("TOPLEFT", chkShowChatMsg, "BOTTOMLEFT")

chkShowLoadMsg:SetScript("OnUpdate", function(frame)
	if DRConfig.ShowLoadMessage == "ON" then
		chkShowLoadMsg:SetChecked(true)
	elseif DRConfig.ShowLoadMessage == "OFF" then
		chkShowLoadMsg:SetChecked(false)
	end
end)

chkShowLoadMsg:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRConfig.ShowLoadMessage = 'OFF'
			if DRConfig.ShowChatMessage == "ON" then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Welcome message disabled."])
			end
	elseif tick == true then
		DRConfig.ShowLoadMessage = 'ON'
			if DRConfig.ShowChatMessage == "ON" then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Welcome message enabled."])
			end
	end
end)

local chkShowLoadMsgText = DRCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkShowLoadMsgText:SetPoint("LEFT", chkShowLoadMsg, "RIGHT", 0, 1)
chkShowLoadMsgText:SetText("|cFFEFC502" .. L["Welcome message"] .. "|r")

-- CATEGORY: DUEL SETTINGS

local lblCatSystemSettings = DRCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblCatSystemSettings:SetPoint("TOPLEFT", chkShowLoadMsg, "BOTTOMLEFT", 0, -8)
lblCatSystemSettings:SetText("|cFFFFFFFF" .. L["Duel Settings"] .. "|r")

-- High Level Check

local chkHighLevel = CreateFrame("CheckButton", nil, DRCIOFrame, "OptionsBaseCheckButtonTemplate")
chkHighLevel:SetPoint("TOPLEFT", lblCatSystemSettings, "BOTTOMLEFT", 0, -8)

chkHighLevel:SetScript("OnUpdate", function(frame)
	if DRConfig.HighLevelCheck == "ENABLED" then
		chkHighLevel:SetChecked(true)
	elseif DRConfig.HighLevelCheck == "DISABLED" then
		chkHighLevel:SetChecked(false)
	end
end)
	
chkHighLevel:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOP")
	GameTooltip:AddLine(L["Declines duel requests you send if the target is 5+ levels above you."], 1, 1, 1)
	GameTooltip:Show()
end)

chkHighLevel:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRConfig.HighLevelCheck = 'DISABLED'
			if DRConfig.ShowChatMessage == "ON" then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["High level check disabled."])
			end
	elseif tick == true then
		DRConfig.HighLevelCheck = 'ENABLED'
			if DRConfig.ShowChatMessage == "ON" then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["High level check enabled."])
			end
	end
end)

local chkHighLevelText = DRCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkHighLevelText:SetPoint("LEFT", chkHighLevel, "RIGHT", 0, 1)
chkHighLevelText:SetText("|cFFEFC502" .. L["High level check for outgoing requests"] .. "|r")

-- Latency Check

local chkAntiLag = CreateFrame("CheckButton", nil, DRCIOFrame, "OptionsBaseCheckButtonTemplate")
chkAntiLag:SetPoint("TOPLEFT", chkHighLevel, "BOTTOMLEFT", 0, -8)

chkAntiLag:SetScript("OnUpdate", function(frame)
	if DRConfig.AntiLag == "ON" then
		chkAntiLag:SetChecked(true)
	elseif DRConfig.AntiLag == "OFF" then
		chkAntiLag:SetChecked(false)
	end
end)

chkAntiLag:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRConfig.AntiLag = 'OFF'
			if DRConfig.ShowChatMessage == "ON" then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Lag check disabled."])
			end
	elseif tick == true then
		DRConfig.AntiLag = 'ON'
			if DRConfig.ShowChatMessage == "ON" then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Lag check enabled."])
			end
	end
end)

local chkAntiLagText = DRCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkAntiLagText:SetPoint("LEFT", chkAntiLag, "RIGHT", 0, 1)
chkAntiLagText:SetText("|cFFEFC502" .. L["Latency Threshold:"] .. "|r")

local txtLatency = CreateFrame("EditBox", nil, DRCIOFrame, "InputBoxTemplate")
txtLatency:SetPoint("LEFT", chkAntiLagText, "RIGHT", 16, 0)
txtLatency:SetAutoFocus(false)
txtLatency:SetWidth(48)
txtLatency:SetHeight(16)
txtLatency:SetMaxLetters(4)
txtLatency:IsNumeric(true)
txtLatency:Show()
txtLatency:Enable(true)

txtLatency:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOP")
	GameTooltip:AddLine(L["Duels will be declined while your World Latency exceeds this number."], 1, 1, 1)
	GameTooltip:Show()
end)

txtLatency:SetScript("OnShow", function(frame)
local text = tonumber(DRConfig.MaxLatency)
	txtLatency:SetText(text)
end)

txtLatency:SetScript("OnEnterPressed", function(self)
	local text = tonumber(txtLatency:GetText())
	
	if text < 1 or text > 500 then
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r |cFFFF0000[" .. L["Error"] .. "]|r " .. L["Maximum latency must be between 1 and 500."])
	else
		DRConfig.MaxLatency = text
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r Maximum latency set to " .. text .. "ms.")
	end
end)

local lblmillisec = DRCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
	lblmillisec:SetPoint("LEFT", txtLatency, "RIGHT", 16, 1)
	lblmillisec:SetText("|cFFEFC502ms|r")
	
-- FPS Check

local chkMinFPS = CreateFrame("CheckButton", nil, DRCIOFrame, "OptionsBaseCheckButtonTemplate")
chkMinFPS:SetPoint("TOPLEFT", chkAntiLag, "BOTTOMLEFT", 0, -8)

chkMinFPS:SetScript("OnUpdate", function(frame)
	if DRConfig.FPSCheck == "ON" then
		chkMinFPS:SetChecked(true)
	elseif DRConfig.FPSCheck == "OFF" then
		chkMinFPS:SetChecked(false)
	end
end)

chkMinFPS:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRConfig.FPSCheck = 'OFF'
			if DRConfig.ShowChatMessage == "ON" then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["FPS check disabled."])
			end
	elseif tick == true then
		DRConfig.FPSCheck = 'ON'
			if DRConfig.ShowChatMessage == "ON" then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["FPS check enabled."])
			end
	end
end)

local chkMinFPSText = DRCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkMinFPSText:SetPoint("LEFT", chkMinFPS, "RIGHT", 0, 1)
chkMinFPSText:SetText("|cFFEFC502" .. L["Framerate Threshold:"] .. "|r")

local txtMinFPS = CreateFrame("EditBox", nil, DRCIOFrame, "InputBoxTemplate")
txtMinFPS:SetPoint("LEFT", chkMinFPSText, "RIGHT", 16, 0)
txtMinFPS:SetAutoFocus(false)
txtMinFPS:SetWidth(48)
txtMinFPS:SetHeight(16)
txtMinFPS:SetMaxLetters(3)
txtMinFPS:IsNumeric(true)
txtMinFPS:Show()
txtMinFPS:Enable(true)

txtMinFPS:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOP")
	GameTooltip:AddLine(L["Duels will be declined while your framerate is below this number."], 1, 1, 1)
	GameTooltip:Show()
end)

txtMinFPS:SetScript("OnShow", function(frame)
local text = tonumber(DRConfig.MinFPS)
	txtMinFPS:SetText(text)
end)
		
local lblFPS = DRCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
	lblFPS:SetPoint("LEFT", txtMinFPS, "RIGHT", 16, 1)
	lblFPS:SetText("|cFFEFC502FPS|r")
	
txtMinFPS:SetScript("OnEnterPressed", function(self)
	local text = tonumber(txtMinFPS:GetText())
	
	if text < 15 or text > 60 then
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r |cFFFF0000[" .. L["Error"] .. "]|r " .. L["Minimum framerate must be between 15 and 60."])
	else
		DRConfig.MinFPS = text
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r Minimum framerate set to " .. text .. "FPS.")
	end
end)

InterfaceOptions_AddCategory(DRCIOFrame);

-- END OF OPTIONS WINDOW

function optionsgui(msg, editbox)

if msg == "" or msg == nil then
	InterfaceOptionsFrame_OpenToCategory(L["DuelResponse"])
	InterfaceOptionsFrame_OpenToCategory(L["DuelResponse"])
	InterfaceOptionsFrame_OpenToCategory(L["DuelResponse"])
elseif msg == L["reset"] or msg == "reset" then
	StaticPopup_Show("RESET_DRVARIABLES")
elseif msg == L["fix"] or msg == "fix" then
	DRConfig.OptionsWindow = 'HIDDEN'
	DRConfig.StatsWindow = 'HIDDEN'
	if IsAddOnLoaded("DuelResponse_Blacklist") == true then DRBConfig.OptionsWindow = 'HIDDEN' end
	if IsAddOnLoaded("DuelResponse_Whisper") == true then DRWConfig.OptionsWindow = 'HIDDEN' end
elseif msg == L["stats"] or msg == "stats" then
	if DRConfig.StatsWindow == "VISIBLE" then
		return
	elseif DRConfig.StatsWindow == "HIDDEN" then
	DRConfig.StatsWindow = 'VISIBLE'

	local drstats = CreateFrame("Frame", "DRConfig", UIParent)
	drstats:SetSize(375, 200) -- WxH
	drstats:SetPoint("CENTER")
	drstats:SetClampedToScreen(true)
	drstats:EnableMouse(true)
	drstats:SetMovable(true)
	drstats:RegisterForDrag("LeftButton")
	drstats:SetScript("OnDragStart", function(self) self:StartMoving() end)
	drstats:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	drstats:Show()
	local bg = drstats:CreateTexture()
	bg:SetAllPoints(drstats)
	bg:SetColorTexture(0, 0, 0, 0.9)
	local hidedrstats = CreateFrame("Button", nil, drstats, "UIPanelCloseButton")
	hidedrstats:SetPoint("TOPRIGHT", drstats, "TOPRIGHT", -5, -5)

	drstats:SetScript("OnHide", function(frame)
		DRConfig.StatsWindow = 'HIDDEN'
	end)

	-- Window Title

	local title = drstats:CreateFontString(nil, nil, "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -16)
	title:SetText("|cFF00FFFF" .. L["DuelResponse"] .. " " .. L["Statistics"])

	-- Status Text

	local statsTitle = drstats:CreateFontString("DRStats", nil, "GameFontHighlight")
	statsTitle:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -16)
	statsTitle:SetText(L["Total duels blocked: "] .. tonumber(GlobalDC) .. " (" ..  UnitName("player") .. ": " .. tonumber(DuelsDeclined) .. ")")

	-- Reset Stats Button

	local btnResetStats = CreateFrame("Button", nil, drstats, "UIPanelButtonTemplate")
	btnResetStats:SetSize(200,25)
	btnResetStats:SetPoint("TOPLEFT", statsTitle, "BOTTOMLEFT", 0, -8)
	btnResetStats:SetScript("OnClick", function(frame)
		StaticPopup_Show("RESET_STATS")
	end)
	btnResetStats:SetText(L["Reset Statistics"])
	
	-- Blacklist Plugin
	
	local lblBlacklistStatus = drstats:CreateFontString(nil, nil, "GameFontHighlight")
	lblBlacklistStatus:SetPoint("TOPLEFT", btnResetStats, "BOTTOMLEFT", 0, -16)
	if IsAddOnLoaded("DuelResponse_Blacklist") == true then
		lblBlacklistStatus:SetText(L["Blacklist plugin is enabled."])
	elseif IsAddOnLoaded("DuelResponse_Blacklist") == false then
		lblBlacklistStatus:SetText(L["Blacklist plugin is disabled."])
	end
	
	-- Whisper Plugin
	
	local lblWhisperStatus = drstats:CreateFontString(nil, nil, "GameFontHighlight")
	lblWhisperStatus:SetPoint("TOPLEFT", lblBlacklistStatus, "BOTTOMLEFT", 0, -8)
	if IsAddOnLoaded("DuelResponse_Whisper") == true then
		lblWhisperStatus:SetText(L["Whisper plugin is enabled."])
	elseif IsAddOnLoaded("DuelResponse_Blacklist") == false then
		lblWhisperStatus:SetText(L["Whisper plugin is disabled."])
	end
	
	-- Blacklist Count
	
	if IsAddOnLoaded("DuelResponse_Blacklist") == true then
		local lblBlacklistCount = drstats:CreateFontString(nil, nil, "GameFontHighlight")
		lblBlacklistCount:SetPoint("TOPLEFT", lblWhisperStatus, "BOTTOMLEFT", 0, -16)
		lblBlacklistCount:SetText(L["Number of players on blacklist: "] .. tablelength(DRBIgnore))
	elseif IsAddOnLoaded("DuelResponse_Blacklist") == false then
		return
	end	
end

end

end

function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end