local AddonName, AddonTable = ...
local L = AddonTable.Localize
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")

playerName = UnitName("player")

function DRBFrame_OnLoad()

	-- Create SavedVariables if they don't exist already
	if DRBConfig == "" or DRBConfig == nil then
		DRBConfig = {
			["ShowLoadMessage"] = "ON",
			["OptionsWindow"] = "HIDDEN"
		}
	end
	
	if DRBIgnore == "" or DRBIgnore == nil then
		DRBIgnore = {}
	end
	
	DRBFrame:RegisterEvent("ADDON_LOADED")
	DRBFrame:RegisterEvent("DUEL_REQUESTED")
		
	-- already hidden by default, but just in case...
	DRBFrame:Hide()
	
	if DRBConfig.OptionsWindow == nil or DRBConfig.OptionsWindow == "" then
		DRBConfig.OptionsWindow = 'HIDDEN'
	end
end

function DRBFrame_OnEvent(self, event, arg1)

if event == "ADDON_LOADED" and arg1 == "DuelResponse_Blacklist" then
	if DRBConfig.ShowLoadMessage == "ON" then
		-- Show these messages in chat when the addon is loaded
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r" .. L[" loaded successfully."])
	else
		return
	end
	
	DRBConfig.OptionsWindow = 'HIDDEN'
elseif event == "DUEL_REQUESTED" then
	if has_value(DRBIgnore, arg1) == true then
		CancelDuel()
		increment_counters()
		
		DRChatMessage(tostring(arg1), L["Blacklisted"])

		if IsAddOnLoaded("DuelResponse_Whisper") == true then
			if UnitIsAFK("player") == true then
				C_ChatInfo.SendAddonMessage("DRBLACKLISTAFK",tostring(arg1),"WHISPER",playerName)
			elseif UnitIsAFK("player") == false then
				C_ChatInfo.SendAddonMessage("DRBLACKLISTED",tostring(arg1),"WHISPER",playerName)
			end
		end
	end
end

end

function has_value (tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end

    return false
end

-- OTHER FUNCTIONS

function increment_counters()

-- Set up variables
local x = tonumber(GlobalDC)
local y = tonumber(DuelsDeclined)

-- Increment counters by 1
x = x + 1
y = y + 1

-- Save new variables
GlobalDC = x
DuelsDeclined = y

end