-- I based this GUI on the one used in the BadBoy anti-spam addon.
-- Consequently, I owe many thanks to Funkydude; permission was given to use his addon in this way.
-- Get BadBoy Anti-Spam here: https://mods.curse.com/addons/wow/bad-boy

local AddonName, AddonTable = ...
local L = AddonTable.Localize
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")

function DRBOptionsFrame_OnLoad()
SlashCmdList["DRBOPTIONS"] = drboptions_command
	SLASH_DRBOPTIONS1 = "/drb"
	
StaticPopupDialogs["RESET_DRBVARIABLES"] = {
  text = L["Reset SavedVariables"] .. "\n\n" .. L["Are you sure?"],
  button1 = L["Yes"],
  button2 = L["No"],
  OnAccept = function()
      resetdrbvariables()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}
end

function resetdrbvariables()

DRBConfig = {
	["ShowLoadMessage"] = "ON",
	["OptionsWindow"] = "HIDDEN"
}

DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r " .. L["Settings returned to default values."])

end

function drboptions_command(msg, editbox)

if msg == "" or msg == nil then
	if DRBConfig.OptionsWindow == "VISIBLE" then
		return
	elseif DRBConfig.OptionsWindow == "HIDDEN" then
		DRBConfig.OptionsWindow = 'VISIBLE'
		local drboptions = CreateFrame("Frame", "DRConfig", UIParent)
		drboptions:SetSize(500, 125) -- WxH
		drboptions:SetPoint("CENTER")
		drboptions:SetClampedToScreen(true)
		drboptions:EnableMouse(true)
		drboptions:SetMovable(true)
		drboptions:RegisterForDrag("LeftButton")
		drboptions:SetScript("OnDragStart", function(self) self:StartMoving() end)
		drboptions:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
		drboptions:Show()
		local bg = drboptions:CreateTexture()
		bg:SetAllPoints(drboptions)
		bg:SetColorTexture(0, 0, 0, 0.9)
		local hidedrboptions = CreateFrame("Button", nil, drboptions, "UIPanelCloseButton")
		hidedrboptions:SetPoint("TOPRIGHT", drboptions, "TOPRIGHT", -5, -5)

		local title = drboptions:CreateFontString(nil, nil, "GameFontNormalLarge")
		title:SetPoint("TOPLEFT", 16, -16)
		title:SetText(L["DuelResponse_Blacklist"])
		
		drboptions:SetScript("OnHide", function(frame)
			DRBConfig.OptionsWindow = 'HIDDEN'
		end)

		-- Add Target Button
		
		local btnAddTarget = CreateFrame("Button", nil, drboptions, "UIPanelButtonTemplate")
		btnAddTarget:SetSize(192,32)
		btnAddTarget:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -16)
		btnAddTarget:SetScript("OnClick", function(frame) addtarget() end)
		btnAddTarget:SetText(L["Add Target"])
		
		-- Remove Target Button
		
		local btnRemoveTarget = CreateFrame("Button", nil, drboptions, "UIPanelButtonTemplate")
		btnRemoveTarget:SetSize(192,32)
		btnRemoveTarget:SetPoint("LEFT", btnAddTarget, "RIGHT", 8, 0)
		btnRemoveTarget:SetScript("OnClick", function(frame) removetarget() end)
		btnRemoveTarget:SetText(L["Remove Target"])
		
		-- Load Message Checkbox

		local chkShowLoadMsg = CreateFrame("CheckButton", nil, drboptions, "OptionsBaseCheckButtonTemplate")
		chkShowLoadMsg:SetPoint("TOPLEFT", btnAddTarget, "BOTTOMLEFT", 0, -8)

		if DRBConfig.ShowLoadMessage == "ON" then
			chkShowLoadMsg:SetChecked(true)
		elseif DRBConfig.ShowLoadMessage == "OFF" then
			chkShowLoadMsg:SetChecked(false)
		end

		chkShowLoadMsg:SetScript("OnClick", function(frame)
		local tick = frame:GetChecked()
	
			if tick == false then
				DRBConfig.ShowLoadMessage = 'OFF'
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r " .. L["Welcome message disabled."])
			elseif tick == true then
				DRBConfig.ShowLoadMessage = 'ON'
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r " .. L["Welcome message enabled."])
			end
		end)

		local chkShowLoadMsgText = drboptions:CreateFontString(nil, nil, "GameFontHighlight")
		chkShowLoadMsgText:SetPoint("LEFT", chkShowLoadMsg, "RIGHT", 0, 1)
		chkShowLoadMsgText:SetText(L["Welcome message"])		
	end
elseif msg == L["reset"] or msg == "reset" then
	StaticPopup_Show("RESET_DRBVARIABLES")
elseif msg == L["add"] or msg == "add" then
	addtarget()
elseif msg == L["remove"] or msg == "remove" then
	removetarget()
end

end

-- ADD AND REMOVE

function addtarget()

local name = UnitName("target")
local isPlayer = UnitIsPlayer("target")
			
if name == nil then
	DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r |cFFFF0000[".. L["Error"] .. "]|r " .. L["Please select a target."])
elseif name == UnitName("player") then
	DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r |cFFFF0000[".. L["Error"] .. "]|r " .. L["You cannot blacklist yourself."])
else
	if isPlayer == false then
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r |cFFFF0000[".. L["Error"] .. "]|r " .. L["Target is not a player."])
	elseif isPlayer == true then
		local tarname, tarrealm = UnitName("target")
					
		if tarrealm == nil then
			if has_value(DRBIgnore, tarname) == true then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r |cFFFF0000[".. L["Error"] .. "]|r " .. tarname .. L[" is already on the list."])
			else
				table.insert(DRBIgnore, tarname)
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r " .. L["Added Player: "] .. tarname .. ".")
			end
		elseif tarrealm ~= myrealm then
			local fulltarname = tarname .. "-" .. tarrealm
						
			if has_value(DRBIgnore, fulltarname) == true then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r |cFFFF0000[".. L["Error"] .. "]|r " .. fulltarname .. L[" is already on the list."])
			else
				table.insert(DRBIgnore, fulltarname)
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r " .. L["Added Player: "] .. fulltarname .. ".")
			end
		end
	end
end

end

function removetarget()

local name = UnitName("target")
local isPlayer = UnitPlayerControlled("target")
			
if name == nil then
	DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r |cFFFF0000[".. L["Error"] .. "]|r " .. L["Please select a target."])
elseif name == UnitName("player") then
	DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r |cFFFF0000[".. L["Error"] .. "]|r " .. L["You're not on the list."])
else
	if isPlayer == false then
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r |cFFFF0000[".. L["Error"] .. "]|r " .. L["Target is not a player."])
	elseif isPlayer == true then
		local tarname, tarrealm = UnitName("target")
			
		if tarrealm == nil then
			if has_value(DRBIgnore, tarname) == false then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r |cFFFF0000[".. L["Error"] .. "]|r " .. tarname .. L[" is not on the list."])
			else
				table.remove(DRBIgnore, tablefind(DRBIgnore, tarname))
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r " .. L["Removed Player: "] .. tarname .. ".")
			end
		elseif tarrealm ~= myrealm then
			local fulltarname = tarname .. "-" .. tarrealm
					
			if has_value(DRBIgnore, fulltarname) == false then
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r |cFFFF0000[".. L["Error"] .. "]|r " .. fulltarname .. L[" is not on the list."])
			else
				table.remove(DRBIgnore, tablefind(DRBIgnore, fulltarname))
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Blacklist"] .."]|r " .. L["Removed Player: "] .. fulltarname .. ".")
			end
		end
	end
end

end

-- TABLE FUNCTIONS

function has_value (tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end

    return false
end

function tablefind(tab,el)
	for index, value in pairs(tab) do
		if value == el then
			return index
			end
	end
end