local AddonName, AddonTable = ...
local L = AddonTable.Localize
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")

GameTooltip:HookScript("OnTooltipSetUnit", function(self)
	local name, unit = self:GetUnit()
	if UnitIsPlayer("mouseover") and not UnitIsUnit("mouseover", "player") then
		local name, realm = UnitName(unit)
		
		if realm == nil then
			name = name
		else
			name = name .. "-" .. (realm or GetRealmName())
		end
		
		if has_value(DRBIgnore, name) then
			self:AddLine(L["Blacklisted"], 1, 0, 0, true)
		end
	end
end)

-- SEARCH FUNCTION

function has_value (tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end

    return false
end