local AddonName, AddonTable = ...
local L = AddonTable.Localize
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")

function DRWFrame_OnLoad()

	local afkListener = CreateFrame("Frame");
	afkListener:RegisterEvent("CHAT_MSG_SYSTEM");
	afkListener:SetScript("OnEvent",function(self, event, msg)
		if (msg:find(L["You are now Away:"]) ~= nil) then
			DRWConfig.AFKMessage = strsub(msg,msg:find(L["You are now Away:"])+18);
		end
	end)

	-- Create SavedVariables if they don't exist already
	if DRWConfig == "" or DRWConfig == nil then
		DRWConfig = {
			["SendMsg"] = 'ON',
			["AllDuels"] = 'Sorry, but I do not duel.',
			["AFKDuel"] = 'I am currently AFK.',
			["DNDDuel"] = 'Sorry, but I am busy at the moment.',
			["HLDuel"] = 'I am currently experiencing a lot of lag.',
			["LowFPS"] = 'I am currently experiencing a low framerate.',
			["OptionsWindow"] = 'HIDDEN',
			["AFKMessage"] = 'AFK.',
			["PetBattle"] = 'Sorry, but I am not into Pet Battles.',
			["WhisperBlacklist"] = 'OFF',
			["BLWhisperMsg"] = 'I am not accepting duels from you.',
			["Branding"] = 'ON'
		}
	end
	
	DRWConfig.OptionsWindow = 'HIDDEN'
	
	DRWFrame:RegisterEvent("ADDON_LOADED")
	DRWFrame:RegisterEvent("VARIABLES_LOADED")
	DRWFrame:RegisterEvent("CHAT_MSG_RESTRICTED")
	
	-- already hidden by default, but just in case...
	DRWFrame:Hide()
end

function afkremember_command(msg, editbox)

	if msg == "" or msg == nil then
		DRWConfig.AFKMessage = 'AFK.'
		SendChatMessage("AFK.", "AFK")
	else
		DRWConfig.AFKMessage = msg
		SendChatMessage(msg, "AFK")
	end

end

function DRWFrame_OnEvent(self, event, arg1)

if event == "ADDON_LOADED" and arg1 == "DuelResponse_Whisper" then
	if DRWConfig.ShowLoadMessage == "ON" then
		-- Show these messages in chat when the addon is loaded
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Whisper"] .."]|r" .. L[" loaded successfully."])
	else
		return
	end
	
	DRWConfig.OptionsWindow = 'HIDDEN'
elseif event == "VARIABLES_LOADED" then
	if DRWConfig.HLDuel == nil then
		DRWConfig.HLDuel = 'I am currently experiencing a lot of lag.'
	end

	if DRWConfig.AFKMessage == nil then
		DRWConfig.AFKMessage = 'AFK.'
	end
	
	if DRWConfig.LowFPS == nil then
		DRWConfig.LowFPS = 'I am currently experiencing a low framerate.'
	end
	
	if DRWConfig.PetBattle == nil then
		DRWConfig.PetBattle = 'Sorry, but I am not into Pet Battles.'
	end
	
	if DRWConfig.WhisperBlacklist == nil then
		DRWConfig.WhisperBlacklist = 'OFF'
	end
	
	if DRWConfig.BLWhisperMsg == nil then
		DRWConfig.BLWhisperMsg = 'I am not accepting duels from you.'
	end
	
	if DRWConfig.Branding == nil then
		DRWConfig.Branding = 'ON'
	end
	
	DRWConfig.OptionsWindow = 'HIDDEN'
elseif event == "CHAT_MSG_RESTRICTED" then
		if DRWConfig.SendMsg == "ON" then
			DRWConfig.SendMsg = 'OFF'
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Whisper"] .."]|r " .. L["Whisper sending has been disabled because you are on a Starter Edition account."])
		else
			return
		end
end

end

function DRWMessageFrame_OnLoad()

DRWMessageFrame:RegisterEvent("CHAT_MSG_ADDON")

decline_all_duels = C_ChatInfo.RegisterAddonMessagePrefix("DRALLDUELS")
player_has_res_sickness = C_ChatInfo.RegisterAddonMessagePrefix("DRRESSICKNESS")
player_has_low_framerate = C_ChatInfo.RegisterAddonMessagePrefix("DRLOWFRAMERATE")
player_has_high_latency = C_ChatInfo.RegisterAddonMessagePrefix("DRHIGHLATENCY")
player_is_afk = C_ChatInfo.RegisterAddonMessagePrefix("DRPLAYERAFK")
player_is_dnd = C_ChatInfo.RegisterAddonMessagePrefix("DRPLAYERDND")
challenger_blacklisted = C_ChatInfo.RegisterAddonMessagePrefix("DRBLACKLISTED")
player_declining_pet_battles = C_ChatInfo.RegisterAddonMessagePrefix("DRPETBATTLE")

decline_all_duels_afk = C_ChatInfo.RegisterAddonMessagePrefix("DRALLDUELSAFK")
player_afk_with_res_sickness = C_ChatInfo.RegisterAddonMessagePrefix("DRRESSICKNESSAFK")
player_afk_with_low_framerate = C_ChatInfo.RegisterAddonMessagePrefix("DRLOWFPSAFK")
player_afk_with_high_latency = C_ChatInfo.RegisterAddonMessagePrefix("DRHIGHLATENCYAFK")
challenger_blacklisted_while_afk = C_ChatInfo.RegisterAddonMessagePrefix("DRBLISTAFK")
player_declining_pet_battles_while_afk = C_ChatInfo.RegisterAddonMessagePrefix("DRPETBATTLEAFK")

end

function DRWMessageFrame_OnEvent(self, event, prefix, message, channel, sender)

if event == "CHAT_MSG_ADDON" then

	if DRWConfig.SendMsg == "OFF" then
		return
	elseif DRWConfig.SendMsg == "ON" then
		local whispertarget = tostring(message)
		
		if prefix == "DRALLDUELS" then
			if DRWConfig.Branding == "ON" then
				SendChatMessage("<" .. L["DuelResponse"] .. "> " .. DRWConfig.AllDuels, "WHISPER", nil, whispertarget)
			elseif DRWConfig.Branding == "OFF" then
				SendChatMessage(DRWConfig.AllDuels, "WHISPER", nil, whispertarget)
			end
		elseif prefix == "DRALLDUELSAFK" then
			if DRWConfig.Branding == "ON" then
				SendChatMessage("<" .. L["DuelResponse"] .. "> " .. DRWConfig.AllDuels, "WHISPER", nil, whispertarget)
				SendChatMessage(DRWConfig.AFKMessage, "AFK")
			elseif DRWConfig.Branding == "OFF" then
				SendChatMessage(DRWConfig.AllDuels, "WHISPER", nil, whispertarget)
				SendChatMessage(DRWConfig.AFKMessage, "AFK")
			end
		elseif prefix == "DRRESSICKNESS" then		
			if DRWConfig.Branding == "ON" then
				SendChatMessage("<" .. L["DuelResponse"] .. "> " .. GetSpellLink(15007), "WHISPER", nil, whispertarget)
			elseif DRWConfig.Branding == "OFF" then
				SendChatMessage(GetSpellLink(15007), "WHISPER", nil, whispertarget)
			end
		elseif prefix == "DRRESSICKNESSAFK" then
			if DRWConfig.Branding == "ON" then
				SendChatMessage("<" .. L["DuelResponse"] .. "> " .. GetSpellLink(15007), "WHISPER", nil, whispertarget)
				SendChatMessage(DRWConfig.AFKMessage, "AFK")
			elseif DRWConfig.Branding == "OFF" then
				SendChatMessage(GetSpellLink(15007), "WHISPER", nil, whispertarget)
				SendChatMessage(DRWConfig.AFKMessage, "AFK")
			end
		elseif prefix == "DRLOWFRAMERATE" then
			if DRWConfig.Branding == "ON" then
				SendChatMessage("<" .. L["DuelResponse"] .. "> " .. DRWConfig.LowFPS, "WHISPER", nil, whispertarget)
			elseif DRWConfig.Branding == "OFF" then
				SendChatMessage(DRWConfig.LowFPS, "WHISPER", nil, whispertarget)
			end
		elseif prefix == "DRLOWFPSAFK" then
			if DRWConfig.Branding == "ON" then
				SendChatMessage("<" .. L["DuelResponse"] .. "> " .. DRWConfig.LowFPS, "WHISPER", nil, whispertarget)
				SendChatMessage(DRWConfig.AFKMessage, "AFK")
			elseif DRWConfig.Branding == "OFF" then
				SendChatMessage(DRWConfig.LowFPS, "WHISPER", nil, whispertarget)
				SendChatMessage(DRWConfig.AFKMessage, "AFK")
			end
		elseif prefix == "DRHIGHLATENCY" then
			if DRWConfig.Branding == "ON" then
				SendChatMessage("<" .. L["DuelResponse"] .. "> " .. DRWConfig.HLDuel, "WHISPER", nil, whispertarget)
			elseif DRWConfig.Branding == "OFF" then
				SendChatMessage(DRWConfig.HLDuel, "WHISPER", nil, whispertarget)
			end
		elseif prefix == "DRHIGHLATENCYAFK" then
			if DRWConfig.Branding == "ON" then
				SendChatMessage("<" .. L["DuelResponse"] .. "> " .. DRWConfig.HLDuel, "WHISPER", nil, whispertarget)
				SendChatMessage(DRWConfig.AFKMessage, "AFK")
			elseif DRWConfig.Branding == "OFF" then
				SendChatMessage(DRWConfig.HLDuel, "WHISPER", nil, whispertarget)
				SendChatMessage(DRWConfig.AFKMessage, "AFK")
			end
		elseif prefix == "DRPLAYERAFK" then
			if DRWConfig.Branding == "ON" then
				SendChatMessage("<" .. L["DuelResponse"] .. "> " .. DRWConfig.AFKDuel, "WHISPER", nil, whispertarget)
				SendChatMessage(DRWConfig.AFKMessage, "AFK")
			elseif DRWConfig.Branding == "OFF" then
				SendChatMessage(DRWConfig.AFKDuel, "WHISPER", nil, whispertarget)
				SendChatMessage(DRWConfig.AFKMessage, "AFK")
			end
		elseif prefix == "DRPLAYERDND" then
			if DRWConfig.Branding == "ON" then
				SendChatMessage("<" .. L["DuelResponse"] .. "> " .. DRWConfig.DNDDuel, "WHISPER", nil, whispertarget)
			elseif DRWConfig.Branding == "OFF" then
				SendChatMessage(DRWConfig.DNDDuel, "WHISPER", nil, whispertarget)
			end
		elseif prefix == "DRBLACKLISTED" then
			if DRWConfig.WhisperBlacklist == "OFF" then
				return
			elseif DRWConfig.WhisperBlacklist == "ON" then
				if DRWConfig.Branding == "ON" then
					SendChatMessage("<" .. L["DuelResponse"] .. "> " .. DRWConfig.BLWhisperMsg, "WHISPER", nil, whispertarget)
				elseif DRWConfig.Branding == "OFF" then
					SendChatMessage(DRWConfig.BLWhisperMsg, "WHISPER", nil, whispertarget)
				end
			end
		elseif prefix == "DRBLISTAFK" then
			if DRWConfig.WhisperBlacklist == "OFF" then
				return
			elseif DRWConfig.WhisperBlacklist == "ON" then
				if DRWConfig.Branding == "ON" then
					SendChatMessage("<" .. L["DuelResponse"] .. "> " .. DRWConfig.BLWhisperMsg, "WHISPER", nil, whispertarget)
					SendChatMessage(DRWConfig.AFKMessage, "AFK")
				elseif DRWConfig.Branding == "OFF" then
					SendChatMessage(DRWConfig.BLWhisperMsg, "WHISPER", nil, whispertarget)
					SendChatMessage(DRWConfig.AFKMessage, "AFK")
				end
			end
		end
	end
end

end