-- I based this GUI on the one used in the BadBoy anti-spam addon.
-- Consequently, I owe many thanks to Funkydude; permission was given to use his addon in this way.
-- Get BadBoy Anti-Spam here: https://mods.curse.com/addons/wow/bad-boy

local AddonName, AddonTable = ...
local L = AddonTable.Localize
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")

function DRWOptionsFrame_OnLoad()
SlashCmdList["DRWOPTIONS"] = drwoptions_command
	SLASH_DRWOPTIONS1 = "/drw"
	
StaticPopupDialogs["RESET_DRWVARIABLES"] = {
  text = L["Reset SavedVariables"] .. "\n\n" .. L["Are you sure?"],
  button1 = L["Yes"],
  button2 = L["No"],
  OnAccept = function()
      resetdrwvariables()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}
end

function resetdrwvariables()

DRWConfig = {
	["SendMsg"] = 'ON',
	["AllDuels"] = 'Sorry, but I do not duel.',
	["AFKDuel"] = 'I am currently AFK.',
	["DNDDuel"] = 'Sorry, but I am busy at the moment.',
	["HLDuel"] = 'I am currently experiencing a lot of lag.',
	["LowFPS"] = 'I am currently experiencing a low framerate.',
	["OptionsWindow"] = 'HIDDEN',
	["AFKMessage"] = 'AFK.',
	["PetBattle"] = 'Sorry, but I am not into Pet Battles.',
	["WhisperBlacklist"] = 'OFF',
	["BLWhisperMsg"] = 'I am not accepting duels from you.',
	["Branding"] = 'ON'
}

DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Whisper"] .."]|r " .. L["Settings returned to default values."])

end

-- START OF OPTIONS WINDOW

local DRWCIOFrame = CreateFrame("Frame")
DRWCIOFrame.name = L["DuelResponse_Whisper"]

local lblTitle = DRWCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblTitle:SetFont("Fonts\\FRIZQT__.TTF", 12)
lblTitle:SetPoint("TOPLEFT", DRWCIOFrame, "TOPLEFT", 12, -12)
lblTitle:SetText(L["DuelResponse_Whisper"])

-- Send Whispers Checkbox

local chkSendWhisper = CreateFrame("CheckButton", nil, DRWCIOFrame, "OptionsBaseCheckButtonTemplate")
chkSendWhisper:SetPoint("TOPLEFT", lblTitle, "BOTTOMLEFT", 0, -16)

chkSendWhisper:SetScript("OnUpdate", function(frame)
	if DRWConfig.SendMsg == "ON" then
		chkSendWhisper:SetChecked(true)
	elseif DRWConfig.SendMsg == "OFF" then
		chkSendWhisper:SetChecked(false)
	end
end)

chkSendWhisper:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	if tick == false then
		DRWConfig.SendMsg = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Whisper"] .."]|r " .. L["Whisper messages disabled."])
	elseif tick == true then
		DRWConfig.SendMsg = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Whisper"] .."]|r " .. L["Whisper messages enabled."])
	end
end)

local chkSendWhisperText = DRWCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkSendWhisperText:SetPoint("LEFT", chkSendWhisper, "RIGHT", 0, 1)
chkSendWhisperText:SetText(L["Send a whisper when a duel is declined"])

-- Load Message Checkbox

local chkShowLoadMsg = CreateFrame("CheckButton", nil, DRWCIOFrame, "OptionsBaseCheckButtonTemplate")
chkShowLoadMsg:SetPoint("TOPLEFT", chkSendWhisper, "BOTTOMLEFT", 0, -8)

chkShowLoadMsg:SetScript("OnUpdate", function(frame)
	if DRWConfig.ShowLoadMessage == "ON" then
		chkShowLoadMsg:SetChecked(true)
	elseif DRWConfig.ShowLoadMessage == "OFF" then
		chkShowLoadMsg:SetChecked(false)
	end
end)

chkShowLoadMsg:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRWConfig.ShowLoadMessage = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Whisper"] .."]|r " .. L["Welcome message disabled."])
	elseif tick == true then
		DRWConfig.ShowLoadMessage = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Whisper"] .."]|r " .. L["Welcome message enabled."])
	end
end)

local chkShowLoadMsgText = DRWCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkShowLoadMsgText:SetPoint("LEFT", chkShowLoadMsg, "RIGHT", 0, 1)
chkShowLoadMsgText:SetText(L["Welcome message"])

-- Branding Checkbox

local chkBranding = CreateFrame("CheckButton", nil, DRWCIOFrame, "OptionsBaseCheckButtonTemplate")
chkBranding:SetPoint("TOPLEFT", chkShowLoadMsg, "BOTTOMLEFT", 0, -8)

chkBranding:SetScript("OnUpdate", function(frame)
	if DRWConfig.Branding == "ON" then
		chkBranding:SetChecked(true)
	elseif DRWConfig.Branding == "OFF" then
		chkBranding:SetChecked(false)
	end
end)

chkBranding:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	if tick == false then
		DRWConfig.Branding = 'OFF'
	elseif tick == true then
		DRWConfig.Branding = 'ON'
	end
end)

chkBranding:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOP")
	GameTooltip:AddLine(L["Toggle this to show or hide <DuelResponse> in sent whispers."], 1, 1, 1)
	GameTooltip:Show()
end)

local chkBrandingText = DRWCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkBrandingText:SetPoint("LEFT", chkBranding, "RIGHT", 0, 1)
chkBrandingText:SetText(L["Enable Branding"])

-- Block All Duels Whisper Editbox

local lblDeclineAllDuelsText = DRWCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblDeclineAllDuelsText:SetPoint("TOPLEFT", chkBranding, "BOTTOMLEFT", 0, -16)
lblDeclineAllDuelsText:SetText(L["Standard Whisper:"])

local txtDeclineAllDuels = CreateFrame("EditBox", nil, DRWCIOFrame, "InputBoxTemplate")
txtDeclineAllDuels:SetPoint("LEFT", lblDeclineAllDuelsText, "RIGHT", 16, 0)
txtDeclineAllDuels:SetAutoFocus(false)
txtDeclineAllDuels:SetWidth(350)
txtDeclineAllDuels:SetHeight(16)
txtDeclineAllDuels:SetMaxLetters(255)
txtDeclineAllDuels:Show()

txtDeclineAllDuels:SetScript("OnShow", function(frame)
local text = DRWConfig.AllDuels
		txtDeclineAllDuels:SetText(text)
end)

txtDeclineAllDuels:SetScript("OnLeave", GameTooltip_Hide)
txtDeclineAllDuels:SetScript("OnEnterPressed", function(frame)
	local text = frame:GetText()
	DRWConfig.AllDuels = text
end)

-- AFK Duels Whisper Editbox

local lblDeclineAFKDuelsText = DRWCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblDeclineAFKDuelsText:SetPoint("TOPLEFT", lblDeclineAllDuelsText, "BOTTOMLEFT", 0, -16)
lblDeclineAFKDuelsText:SetText(L["Away Whisper:"])

local txtDeclineAFKDuels = CreateFrame("EditBox", nil, DRWCIOFrame, "InputBoxTemplate")
txtDeclineAFKDuels:SetPoint("LEFT", lblDeclineAFKDuelsText, "RIGHT", 16, 0)
txtDeclineAFKDuels:SetAutoFocus(false)
txtDeclineAFKDuels:SetWidth(350)
txtDeclineAFKDuels:SetHeight(16)
txtDeclineAFKDuels:SetMaxLetters(255)
txtDeclineAFKDuels:Show()

txtDeclineAFKDuels:SetScript("OnShow", function(frame)
local text = DRWConfig.AFKDuel
		txtDeclineAFKDuels:SetText(text)
end)

txtDeclineAFKDuels:SetScript("OnLeave", GameTooltip_Hide)
txtDeclineAFKDuels:SetScript("OnEnterPressed", function(frame)
	local text = frame:GetText()
	DRWConfig.AFKDuel = text
end)

-- DND Duels Whisper Editbox

local lblDeclineDNDDuelsText = DRWCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblDeclineDNDDuelsText:SetPoint("TOPLEFT", lblDeclineAFKDuelsText, "BOTTOMLEFT", 0, -16)
lblDeclineDNDDuelsText:SetText(L["Busy Whisper:"])

local txtDeclineDNDDuels = CreateFrame("EditBox", nil, DRWCIOFrame, "InputBoxTemplate")
txtDeclineDNDDuels:SetPoint("LEFT", lblDeclineDNDDuelsText, "RIGHT", 16, 0)
txtDeclineDNDDuels:SetAutoFocus(false)
txtDeclineDNDDuels:SetWidth(350)
txtDeclineDNDDuels:SetHeight(16)
txtDeclineDNDDuels:SetMaxLetters(255)
txtDeclineDNDDuels:Show()

txtDeclineDNDDuels:SetScript("OnShow", function(frame)
local text = DRWConfig.DNDDuel
		txtDeclineDNDDuels:SetText(text)
end)

txtDeclineDNDDuels:SetScript("OnLeave", GameTooltip_Hide)
txtDeclineDNDDuels:SetScript("OnEnterPressed", function(frame)
	local text = frame:GetText()
	DRWConfig.DNDDuel = text
end)

-- High Latency Whisper Editbox

local lblDeclineHighLatencyDuelsText = DRWCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblDeclineHighLatencyDuelsText:SetPoint("TOPLEFT", lblDeclineDNDDuelsText, "BOTTOMLEFT", 0, -16)
lblDeclineHighLatencyDuelsText:SetText(L["High Latency Whisper:"])

local txtDeclineHighLatencyDuels = CreateFrame("EditBox", nil, DRWCIOFrame, "InputBoxTemplate")
txtDeclineHighLatencyDuels:SetPoint("LEFT", lblDeclineHighLatencyDuelsText, "RIGHT", 16, 0)
txtDeclineHighLatencyDuels:SetAutoFocus(false)
txtDeclineHighLatencyDuels:SetWidth(350)
txtDeclineHighLatencyDuels:SetHeight(16)
txtDeclineHighLatencyDuels:SetMaxLetters(255)
txtDeclineHighLatencyDuels:Show()

txtDeclineHighLatencyDuels:SetScript("OnShow", function(frame)
local text = DRWConfig.HLDuel
		txtDeclineHighLatencyDuels:SetText(text)
end)

txtDeclineHighLatencyDuels:SetScript("OnLeave", GameTooltip_Hide)
txtDeclineHighLatencyDuels:SetScript("OnEnterPressed", function(frame)
	local text = frame:GetText()
	DRWConfig.HLDuel = text
end)

-- Low FPS Whisper Editbox

local lblDeclineLowFPSDuelsText = DRWCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblDeclineLowFPSDuelsText:SetPoint("TOPLEFT", lblDeclineHighLatencyDuelsText, "BOTTOMLEFT", 0, -16)
lblDeclineLowFPSDuelsText:SetText(L["Low FPS Whisper:"])

local lblDeclineLowFPSDuels = CreateFrame("EditBox", nil, DRWCIOFrame, "InputBoxTemplate")
lblDeclineLowFPSDuels:SetPoint("LEFT", lblDeclineLowFPSDuelsText, "RIGHT", 16, 0)
lblDeclineLowFPSDuels:SetAutoFocus(false)
lblDeclineLowFPSDuels:SetWidth(350)
lblDeclineLowFPSDuels:SetHeight(16)
lblDeclineLowFPSDuels:SetMaxLetters(255)
lblDeclineLowFPSDuels:Show()

lblDeclineLowFPSDuels:SetScript("OnShow", function(frame)
local text = DRWConfig.LowFPS
		lblDeclineLowFPSDuels:SetText(text)
end)

lblDeclineLowFPSDuels:SetScript("OnLeave", GameTooltip_Hide)
lblDeclineLowFPSDuels:SetScript("OnEnterPressed", function(frame)
	local text = frame:GetText()
	DRWConfig.LowFPS = text
end)

-- Decline Pet Battle Whisper Editbox

local lblDeclinePetBattleText = DRWCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblDeclinePetBattleText:SetPoint("TOPLEFT", lblDeclineLowFPSDuelsText, "BOTTOMLEFT", 0, -16)
lblDeclinePetBattleText:SetText(L["Pet Battle Refused:"])

local lblDeclinePetBattle = CreateFrame("EditBox", nil, DRWCIOFrame, "InputBoxTemplate")
lblDeclinePetBattle:SetPoint("LEFT", lblDeclinePetBattleText, "RIGHT", 16, 0)
lblDeclinePetBattle:SetAutoFocus(false)
lblDeclinePetBattle:SetWidth(350)
lblDeclinePetBattle:SetHeight(16)
lblDeclinePetBattle:SetMaxLetters(255)
lblDeclinePetBattle:Show()

lblDeclinePetBattle:SetScript("OnShow", function(frame)
local text = DRWConfig.PetBattle
		lblDeclinePetBattle:SetText(text)
end)

lblDeclinePetBattle:SetScript("OnLeave", GameTooltip_Hide)
lblDeclinePetBattle:SetScript("OnEnterPressed", function(frame)
	local text = frame:GetText()
	DRWConfig.PetBattle = text
end)

-- Whisper Blacklisted Players Checkbox

local chkWhisperBL = CreateFrame("CheckButton", nil, DRWCIOFrame, "OptionsBaseCheckButtonTemplate")
chkWhisperBL:SetPoint("TOPLEFT", lblDeclinePetBattleText, "BOTTOMLEFT", 0, -8)

chkWhisperBL:SetScript("OnUpdate", function(frame)
	if DRWConfig.WhisperBlacklist == "ON" then
		chkWhisperBL:SetChecked(true)
	elseif DRWConfig.WhisperBlacklist == "OFF" then
		chkWhisperBL:SetChecked(false)
	end
end)

chkWhisperBL:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRWConfig.WhisperBlacklist = 'OFF'
	elseif tick == true then
		DRWConfig.WhisperBlacklist = 'ON'
	end
end)

local chkWhisperBLText = DRWCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkWhisperBLText:SetPoint("LEFT", chkWhisperBL, "RIGHT", 0, 1)
chkWhisperBLText:SetText(L["Send a whisper to blacklisted players"])

-- Blacklisted Player Whisper Editbox

local lblBLPlayerMsgText = DRWCIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblBLPlayerMsgText:SetPoint("TOPLEFT", chkWhisperBL, "BOTTOMLEFT", 0, -8)
lblBLPlayerMsgText:SetText(L["Blacklisted Player:"])

local txtBLPlayerMsg = CreateFrame("EditBox", nil, DRWCIOFrame, "InputBoxTemplate")
txtBLPlayerMsg:SetPoint("LEFT", lblBLPlayerMsgText, "RIGHT", 16, 0)
txtBLPlayerMsg:SetAutoFocus(false)
txtBLPlayerMsg:SetWidth(350)
txtBLPlayerMsg:SetHeight(16)
txtBLPlayerMsg:SetMaxLetters(255)
txtBLPlayerMsg:Show()

txtBLPlayerMsg:SetScript("OnShow", function(frame)
local text = DRWConfig.BLWhisperMsg
		txtBLPlayerMsg:SetText(text)
end)

txtBLPlayerMsg:SetScript("OnLeave", GameTooltip_Hide)
txtBLPlayerMsg:SetScript("OnEnterPressed", function(frame)
	local text = frame:GetText()
	DRWConfig.BLWhisperMsg = text
end)

-- Save All Messages Button

local btnSaveAll = CreateFrame("Button", nil, DRWCIOFrame, "UIPanelButtonTemplate")
btnSaveAll:SetSize(192,32)
btnSaveAll:SetPoint("TOPLEFT", lblDeclinePetBattleText, "BOTTOMLEFT", 0, -72)
btnSaveAll:SetScript("OnClick", function(frame)

local allduels = txtDeclineAllDuels:GetText()
local playerafk = txtDeclineAFKDuels:GetText()
local playerdnd = txtDeclineDNDDuels:GetText()
local lagging = txtDeclineHighLatencyDuels:GetText()
local lowFPSMessage = lblDeclineLowFPSDuels:GetText()
local petbattles = lblDeclinePetBattle:GetText()
local blacklist = txtBLPlayerMsg:GetText()

DRWConfig.AllDuels = allduels
DRWConfig.AFKDuel = playerafk
DRWConfig.DNDDuel = playerdnd
DRWConfig.HLDuel = lagging
DRWConfig.LowFPS = lowFPSMessage
DRWConfig.PetBattle = petbattles
DRWConfig.BLWhisperMsg = blacklist

DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Whisper"] .."]|r " .. L["Messages saved."])

end)
btnSaveAll:SetText(L["Save All Whispers"])

InterfaceOptions_AddCategory(DRWCIOFrame)

function drwoptions_command(msg, editbox)
	if msg == "" or msg == nil then
		InterfaceOptionsFrame_OpenToCategory(L["DuelResponse_Whisper"])
		InterfaceOptionsFrame_OpenToCategory(L["DuelResponse_Whisper"])
		InterfaceOptionsFrame_OpenToCategory(L["DuelResponse_Whisper"])
	elseif msg == L["reset"] or msg == "reset" then
		StaticPopup_Show("RESET_DRWVARIABLES")
	end
end

function SaveAllWhispers()

end